package com.alterdekim.game.entity;


import com.alterdekim.game.xml.NumericBooleanSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRootName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="miniquests")
@JsonRootName(value = "i")
public class Miniquest {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @JsonProperty
    private Long Id;

    @JsonIgnore
    @Column(nullable = false)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean isTask;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private Long MiniquestId;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean IsPostponed;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean IsFinished;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private String StartDate;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private Integer Counter;
}
